import Taro, { Component } from '@tarojs/taro'
import { View, Button, Text, Image } from '@tarojs/components'
import { AtIcon, AtModal, AtModalHeader, AtModalContent, AtModalAction, AtInput, AtNoticebar } from 'taro-ui'


import './filteredShopComponent.scss'
import URL from '../../serviceAPI.config'

const hornIcon = require('../../icons/horn.png')
const houseIcon = require('../../icons/house.png')

class recommondShop extends Component {
    static options = {
        addGlobalClass: true
    }

    config = {
        navigationBarTitleText: 'recommondShop'
    }
    constructor() {
        super(...arguments);
        this.state = {
            isOpenVouhcer: false,
            isOpenConsult: false,
            consultTip: '',
            voucherResponseMsg: '',
            voucherCanConsult: false,
            voucherName:this.props.userName,
            voucherPhone:this.props.userPhone,
            consultName:this.props.userName,
            consultPhone:this.props.userPhone,
        }
    }
    goToShop(value) {
        Taro.navigateTo({
            url: '/pages/shop/shop?id=' + value.shop_id 
        })
    }
    // api 优惠卷请求  
    getVoucherInfo({ user = "杨夕兵", phone = "18950295811", shops = ["808"], source_type = 4, flag = false, source_class = "1", source_level = 1 }) {
        Taro.request({
            url: URL.GetVoucherInfo,
            method: 'POST',
            dataType: 'json',
            data: {
                user: user,
                phone: phone,
                shops: shops,
                source_type: source_type,
                flag: flag,
                source_class: source_class,
                source_level: source_level
            },
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                this.setState({
                    voucherResponseMsg: res.data.tips,
                    voucherCanConsult: res.data.canConsult
                })
                console.log('优惠卷请求', res)
            })

    }
    // api 咨询信息 

    getConsultInfo({ user = "杨夕兵", phone = "18950295811", shops = ["1306"], source_type = "2", flag = false, source_level = 1 }) {
        Taro.request({
            url: URL.GetConsultInfo,
            method: 'POST',
            dataType: 'json',
            data: {
                user: user,
                phone: phone,
                shops: shops,
                source_type: source_type,
                flag: flag,
                source_level: source_level
            },
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                this.setState({ consultTip: res.data.tips })
                console.log('咨询请求', res)
            })
    }
    // api 购买咨询 BuyConsult
    buyConsult({ user = "杨夕兵", phone = "18950295811", shops = ["1306"], source_type = "2", source_level = 1, coupons_flag = 0 }) {
        Taro.request({
            url: URL.BuyConsult,
            method: 'POST',
            dataType: 'json',
            data: {
                data: JSON.stringify({
                    user: user,
                    phone: phone,
                    shops: shops,
                    source_type: source_type,
                    source_level: source_level,
                    coupons_flag: coupons_flag,
                })
            },
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                console.log('购买咨询请求成功', res)
                if (res.statusCode === 200) {                   
                   Taro.showToast({ title: res.data.err_msg,icon:'success' })
                } else {
                    Taro.showToast({ title: res.data.err_msg,icon:'none' })
                   
                }
            }).catch(err=>{
                console.log('购买咨询请求失败', err)
            })
    }

    // 优惠卷弹框。取消。确认
    isOpenVoucher() {
        this.setState({ isOpenVouhcer: true })
        this.getVoucherInfo({})
    }
    voucherModalClose() {
        this.setState({ isOpenVouhcer: false })
    }
    voucherModalConfirm() {
        this.setState({ isOpenVouhcer: false })
        this.buyConsult({user:this.state.voucherName,phone:this.state.voucherPhone})
    }
    // 咨询弹框。取消。确认
    isOpenConsult() {
        this.setState({ isOpenConsult: true })
        this.getConsultInfo({})
    }
    consultModalClose() {
        this.setState({ isOpenConsult: false })
    }
    consultModalConfirm() {
        this.setState({ isOpenConsult: false })
        this.buyConsult({user:this.state.consultName,phone:this.state.consultPhone})
    }
    handleInputVcherPhone(value){
         this.setState({voucherPhone:value})
    }
    handleInputVcherName(value){
        this.setState({voucherName:value})
    }
    handleInputCsultName(value){
        this.setState({consultName:value})
    }
    handleInputCsultPhone(value){
        this.setState({consultPhone:value})
    }


    componentWillReceiveProps(nextProps) {
        //console.log(this.props, nextProps)
    }
    componentDidMount() {

    }
    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        // console.log('店铺',this.props.shop)

        const title = this.props.shop ? this.props.shop.shop_name : null
        const imgUrl = this.props.shop ? URL.Base + this.props.shop.goods[0].goods_url : null
        const price = this.props.shop ? this.props.shop.goods[0].goods_price : null
        const goods = this.props.shop ? this.props.shop.goods : null
        const ProductName = this.props.shop ? this.props.shop.goods[0].goods_name : null
        const address = this.props.shop ? this.props.shop.shop_address : null
        const distance = this.props.shop ? this.props.shop.distance : null
        const ads = this.props.shop ? this.props.shop.ads : null
        const voucherLeft = this.props.shop ? this.props.shop.left_nums : null
        // const consultText = this.props.shop.wx_open
        const slicedGoods = goods !== null ? goods.slice(1) : null
        const goodsElementsArray = goods !== null ? slicedGoods.map((item, index) => {
            return <View className='goods-img-box' key={index}>
                <Image className='goods-img' onClick={this.goToShop.bind(this, this.props.shop)} mode='aspectFit' style='max-height: 100%; max-width: 100%;' src={URL.Base + item.goods_url} />
            </View>
        }) : null
        //  优惠卷和咨询元素
        const voucherModalElement = <AtModal className='voucher-modal' isOpened={this.state.isOpenVouhcer}>
            <AtModalHeader>优惠卷须知：</AtModalHeader>
            <AtModalContent>
                <AtNoticebar >
                    <Text className='orange' > 提示：具体可以前往实体店进行领取优惠卷或通过电话进行咨询</Text>
                </AtNoticebar>
                <View className='voucher-left'>当前优惠卷{voucherLeft}张</View>
                <AtInput
                  name='value'
                  title='联系人：'
                  type='text'
                  value={this.state.voucherName}
                  onChange={this.handleInputVcherName.bind(this)}
                />
                <AtInput
                  border={false}
                  name='value'
                  title='联系电话：'
                  type='number'
                  value={this.state.voucherPhone}
                  onChange={this.handleInputVcherPhone.bind(this)}

                />
                {!this.state.voucherCanConsult ? <View className='voucher-ResponseMsg'>{this.state.voucherResponseMsg}</View> : null}

            </AtModalContent>
            <AtModalAction> <Button onClick={this.voucherModalClose.bind(this)} >取消</Button> <Button className='orange' onClick={this.voucherModalConfirm.bind(this)}>确定</Button> </AtModalAction>
        </AtModal>
        const consultModalElement = <AtModal isOpened={this.state.isOpenConsult}>
            <AtModalHeader>咨询</AtModalHeader>
            <AtModalContent>

                <AtNoticebar >
                    <Text className='orange' >提示:{this.state.consultTip}</Text>
                </AtNoticebar>


                <AtInput
                  name='value'
                  title='联系人：'
                  type='text'
                  value={this.state.consultName}
                  onChange={this.handleInputCsultName.bind(this)}
                />
                <AtInput
                  name='value'
                  title='联系电话：'
                  type='number'
                  value={this.state.consultPhone}
                  border={false}
                  onChange={this.handleInputCsultPhone.bind(this)}
                />
            </AtModalContent>
            <AtModalAction> <Button onClick={this.consultModalClose.bind(this)} >取消</Button> <Button className='orange' onClick={this.consultModalConfirm.bind(this)}>确定</Button> </AtModalAction>
        </AtModal>

       
        return (
            <View className='shop-list-box' >
                {voucherModalElement}
                {consultModalElement}
            
                <View className='header'>
                    <View className='title'>
                        <Image src={ads !== 0 ? hornIcon : houseIcon} style='width:12px; height:12px; vertical-align: middle;' />
                        <Text style='margin-left:2px; vertical-align: middle;'>  {title}</Text>
                    </View>
                    <View className='consult-voucher-button' style='margin-right:5px'>
                        {voucherLeft ? <Button onClick={this.isOpenVoucher.bind(this)} style='padding:0' className='voucher-button-text voucher' >优惠卷</Button> : <Button style='padding:0' className='voucher-button-text'>优惠卷</Button>}


                        <Button onClick={this.isOpenConsult.bind(this)} style='padding:0' className='consult-button-text'>询价</Button>

                    </View>
                </View>
                <View className='body'>
                    <View className='shop-img' onClick={this.goToShop.bind(this, this.props.shop)}>
                        <Image mode='aspectFit' style=' max-height: 100%; max-width: 100%;' src={imgUrl} />
                    </View>
                    {goods.length !== 1 ? <View className='images'>{goodsElementsArray}</View> : <View className='details'>
                        <View className='details-block'><Text className='details-text'>商品:</Text> {ProductName}</View>
                        <View className='details-block'><Text className='details-text'>价格: </Text><Text>{price}</Text></View>
                    </View>}

                </View>
                <View className='footer'>
                    <View className='address'>
                        <AtIcon value='map-pin' size='15' color='#999'></AtIcon>
                        <Text>{address} </Text> </View>
                    <View className='distance'><Text>{distance}</Text></View>

                </View>
            </View>
        )
    }
}

export default recommondShop
